/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         mpparse
#define yylex           mplex
#define yyerror         mperror
#define yydebug         mpdebug
#define yynerrs         mpnerrs
#define yylval          mplval
#define yychar          mpchar

/* First part of user prologue.  */
#line 1 "parser.y"

/*
 * Copyright 2001, THE AUTHOR <mibparser@cvtt.net>
 * All rights reserved.
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * A parser for the basic grammar to use for snmp V2c modules
 */

#ifdef _WIN32
#pragma warning(disable : 4065 4102)
#endif

/*
#ifndef __STDC__
#define __STDC__	1
#endif
*/

#define YYMALLOC	MemAlloc
#define YYFREE		MemFree

#include <nms_common.h>
#include <nms_util.h>
#include <string.h>
#include <time.h>
#include "mibparse.h"
#include "nxmibc.h"
#include "nxsnmp.h"

#define YYINCLUDED_STDLIB_H		1

#ifdef YYTEXT_POINTER
extern char *mptext;
#else
extern char mptext[];
#endif

#ifdef __64BIT__
#define YYSIZE_T  int64_t
#endif

extern FILE *mpin, *mpout;
extern int g_nCurrLine;

static MP_MODULE *m_pModule;
static MP_SYNTAX *s_currentSyntaxObject = nullptr;
#ifdef UNICODE
static char s_currentFilename[MAX_PATH];
#else
static const char *s_currentFilename;
#endif

int mperror(const char *pszMsg);
int mplex(void);
void ResetScanner();

MP_SYNTAX *create_std_syntax(int nSyntax)
{
   MP_SYNTAX *p = new MP_SYNTAX;
   p->nSyntax = nSyntax;
   return p;
}

static int AccessFromText(const char *pszText)
{
   static const char *pText[] = { "read-only", "read-write", "write-only",
                                  "not-accessible", "accessible-for-notify",
                                  "read-create", nullptr };
   for(int i = 0; pText[i] != nullptr; i++)
      if (strcmp(pszText, pText[i]))
         return i + 1;

   char szBuffer[256];
   sprintf(szBuffer, "Invalid ACCESS value \"%s\"", pszText);
   mperror(szBuffer);
   return -1;
}


#line 187 "parser.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ENTERPRISE_SYM = 3,             /* ENTERPRISE_SYM  */
  YYSYMBOL_TRAP_TYPE_SYM = 4,              /* TRAP_TYPE_SYM  */
  YYSYMBOL_VARIABLES_SYM = 5,              /* VARIABLES_SYM  */
  YYSYMBOL_EXPLICIT_SYM = 6,               /* EXPLICIT_SYM  */
  YYSYMBOL_IMPLICIT_SYM = 7,               /* IMPLICIT_SYM  */
  YYSYMBOL_IMPLIED_SYM = 8,                /* IMPLIED_SYM  */
  YYSYMBOL_RIGHT_BRACE_SYM = 9,            /* RIGHT_BRACE_SYM  */
  YYSYMBOL_LEFT_BRACE_SYM = 10,            /* LEFT_BRACE_SYM  */
  YYSYMBOL_RIGHT_BRACKET_SYM = 11,         /* RIGHT_BRACKET_SYM  */
  YYSYMBOL_LEFT_BRACKET_SYM = 12,          /* LEFT_BRACKET_SYM  */
  YYSYMBOL_DEFINITIONS_SYM = 13,           /* DEFINITIONS_SYM  */
  YYSYMBOL_ASSIGNMENT_SYM = 14,            /* ASSIGNMENT_SYM  */
  YYSYMBOL_BEGIN_SYM = 15,                 /* BEGIN_SYM  */
  YYSYMBOL_END_SYM = 16,                   /* END_SYM  */
  YYSYMBOL_FROM_SYM = 17,                  /* FROM_SYM  */
  YYSYMBOL_IMPORTS_SYM = 18,               /* IMPORTS_SYM  */
  YYSYMBOL_EXPORTS_SYM = 19,               /* EXPORTS_SYM  */
  YYSYMBOL_COMMA_SYM = 20,                 /* COMMA_SYM  */
  YYSYMBOL_SEMI_COLON_SYM = 21,            /* SEMI_COLON_SYM  */
  YYSYMBOL_DOT_SYM = 22,                   /* DOT_SYM  */
  YYSYMBOL_DESCRIPTION_SYM = 23,           /* DESCRIPTION_SYM  */
  YYSYMBOL_ORGANIZATION_SYM = 24,          /* ORGANIZATION_SYM  */
  YYSYMBOL_CONTACT_SYM = 25,               /* CONTACT_SYM  */
  YYSYMBOL_UPDATE_SYM = 26,                /* UPDATE_SYM  */
  YYSYMBOL_MODULE_IDENTITY_SYM = 27,       /* MODULE_IDENTITY_SYM  */
  YYSYMBOL_MODULE_COMPLIANCE_SYM = 28,     /* MODULE_COMPLIANCE_SYM  */
  YYSYMBOL_OBJECT_IDENTIFIER_SYM = 29,     /* OBJECT_IDENTIFIER_SYM  */
  YYSYMBOL_OBJECT_TYPE_SYM = 30,           /* OBJECT_TYPE_SYM  */
  YYSYMBOL_OBJECT_GROUP_SYM = 31,          /* OBJECT_GROUP_SYM  */
  YYSYMBOL_OBJECT_IDENTITY_SYM = 32,       /* OBJECT_IDENTITY_SYM  */
  YYSYMBOL_OBJECTS_SYM = 33,               /* OBJECTS_SYM  */
  YYSYMBOL_MANDATORY_GROUPS_SYM = 34,      /* MANDATORY_GROUPS_SYM  */
  YYSYMBOL_GROUP_SYM = 35,                 /* GROUP_SYM  */
  YYSYMBOL_AGENT_CAPABILITIES_SYM = 36,    /* AGENT_CAPABILITIES_SYM  */
  YYSYMBOL_KEYWORD_SYM = 37,               /* KEYWORD_SYM  */
  YYSYMBOL_KEYWORD_VALUE_SYM = 38,         /* KEYWORD_VALUE_SYM  */
  YYSYMBOL_KEYWORD_BIND_SYM = 39,          /* KEYWORD_BIND_SYM  */
  YYSYMBOL_TOKEN_SYM = 40,                 /* TOKEN_SYM  */
  YYSYMBOL_INTEGER_SYM = 41,               /* INTEGER_SYM  */
  YYSYMBOL_INTEGER32_SYM = 42,             /* INTEGER32_SYM  */
  YYSYMBOL_UNSIGNED32_SYM = 43,            /* UNSIGNED32_SYM  */
  YYSYMBOL_GAUGE32_SYM = 44,               /* GAUGE32_SYM  */
  YYSYMBOL_COUNTER_SYM = 45,               /* COUNTER_SYM  */
  YYSYMBOL_COUNTER32_SYM = 46,             /* COUNTER32_SYM  */
  YYSYMBOL_COUNTER64_SYM = 47,             /* COUNTER64_SYM  */
  YYSYMBOL_BITS_SYM = 48,                  /* BITS_SYM  */
  YYSYMBOL_STRING_SYM = 49,                /* STRING_SYM  */
  YYSYMBOL_OCTET_SYM = 50,                 /* OCTET_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 51,              /* SEQUENCE_SYM  */
  YYSYMBOL_OF_SYM = 52,                    /* OF_SYM  */
  YYSYMBOL_TIMETICKS_SYM = 53,             /* TIMETICKS_SYM  */
  YYSYMBOL_IP_ADDRESS_SYM = 54,            /* IP_ADDRESS_SYM  */
  YYSYMBOL_NETWORK_ADDRESS_SYM = 55,       /* NETWORK_ADDRESS_SYM  */
  YYSYMBOL_OPAQUE_SYM = 56,                /* OPAQUE_SYM  */
  YYSYMBOL_REVISION_SYM = 57,              /* REVISION_SYM  */
  YYSYMBOL_TEXTUAL_CONVENTION_SYM = 58,    /* TEXTUAL_CONVENTION_SYM  */
  YYSYMBOL_ACCESS_SYM = 59,                /* ACCESS_SYM  */
  YYSYMBOL_MAX_ACCESS_SYM = 60,            /* MAX_ACCESS_SYM  */
  YYSYMBOL_MIN_ACCESS_SYM = 61,            /* MIN_ACCESS_SYM  */
  YYSYMBOL_SYNTAX_SYM = 62,                /* SYNTAX_SYM  */
  YYSYMBOL_STATUS_SYM = 63,                /* STATUS_SYM  */
  YYSYMBOL_INDEX_SYM = 64,                 /* INDEX_SYM  */
  YYSYMBOL_REFERENCE_SYM = 65,             /* REFERENCE_SYM  */
  YYSYMBOL_DEFVAL_SYM = 66,                /* DEFVAL_SYM  */
  YYSYMBOL_LEFT_PAREN_SYM = 67,            /* LEFT_PAREN_SYM  */
  YYSYMBOL_RIGHT_PAREN_SYM = 68,           /* RIGHT_PAREN_SYM  */
  YYSYMBOL_NOTIFICATIONS_SYM = 69,         /* NOTIFICATIONS_SYM  */
  YYSYMBOL_NOTIFICATION_GROUP_SYM = 70,    /* NOTIFICATION_GROUP_SYM  */
  YYSYMBOL_NOTIFICATION_TYPE_SYM = 71,     /* NOTIFICATION_TYPE_SYM  */
  YYSYMBOL_SIZE_SYM = 72,                  /* SIZE_SYM  */
  YYSYMBOL_BAR_SYM = 73,                   /* BAR_SYM  */
  YYSYMBOL_VARIATION_SYM = 74,             /* VARIATION_SYM  */
  YYSYMBOL_WRITE_SYNTAX_SYM = 75,          /* WRITE_SYNTAX_SYM  */
  YYSYMBOL_SUPPORTS_SYM = 76,              /* SUPPORTS_SYM  */
  YYSYMBOL_INCLUDES_SYM = 77,              /* INCLUDES_SYM  */
  YYSYMBOL_CREATION_REQUIRES_SYM = 78,     /* CREATION_REQUIRES_SYM  */
  YYSYMBOL_PRODUCT_RELEASE_SYM = 79,       /* PRODUCT_RELEASE_SYM  */
  YYSYMBOL_CHOICE_SYM = 80,                /* CHOICE_SYM  */
  YYSYMBOL_UNITS_SYM = 81,                 /* UNITS_SYM  */
  YYSYMBOL_AUGMENTS_SYM = 82,              /* AUGMENTS_SYM  */
  YYSYMBOL_OBJECT_SYM = 83,                /* OBJECT_SYM  */
  YYSYMBOL_TAGS_SYM = 84,                  /* TAGS_SYM  */
  YYSYMBOL_AUTOMATIC_SYM = 85,             /* AUTOMATIC_SYM  */
  YYSYMBOL_MIN_SYM = 86,                   /* MIN_SYM  */
  YYSYMBOL_MAX_SYM = 87,                   /* MAX_SYM  */
  YYSYMBOL_MODULE_SYM = 88,                /* MODULE_SYM  */
  YYSYMBOL_MACRO_SYM = 89,                 /* MACRO_SYM  */
  YYSYMBOL_UCASEFIRST_IDENT_SYM = 90,      /* UCASEFIRST_IDENT_SYM  */
  YYSYMBOL_LCASEFIRST_IDENT_SYM = 91,      /* LCASEFIRST_IDENT_SYM  */
  YYSYMBOL_BSTRING_SYM = 92,               /* BSTRING_SYM  */
  YYSYMBOL_HSTRING_SYM = 93,               /* HSTRING_SYM  */
  YYSYMBOL_CSTRING_SYM = 94,               /* CSTRING_SYM  */
  YYSYMBOL_DISPLAY_HINT_SYM = 95,          /* DISPLAY_HINT_SYM  */
  YYSYMBOL_NUMBER_SYM = 96,                /* NUMBER_SYM  */
  YYSYMBOL_YYACCEPT = 97,                  /* $accept  */
  YYSYMBOL_ModuleDefinition = 98,          /* ModuleDefinition  */
  YYSYMBOL_AssignmentList = 99,            /* AssignmentList  */
  YYSYMBOL_Assignment = 100,               /* Assignment  */
  YYSYMBOL_ModuleIdentifierAssignment = 101, /* ModuleIdentifierAssignment  */
  YYSYMBOL_ModuleIdentifier = 102,         /* ModuleIdentifier  */
  YYSYMBOL_ObjectIdentifierAssignment = 103, /* ObjectIdentifierAssignment  */
  YYSYMBOL_AssignedIdentifier = 104,       /* AssignedIdentifier  */
  YYSYMBOL_AssignedIdentifierList = 105,   /* AssignedIdentifierList  */
  YYSYMBOL_ObjectIdentifierList = 106,     /* ObjectIdentifierList  */
  YYSYMBOL_ObjectIdentifier = 107,         /* ObjectIdentifier  */
  YYSYMBOL_NumericValue = 108,             /* NumericValue  */
  YYSYMBOL_NumberOrMinMax = 109,           /* NumberOrMinMax  */
  YYSYMBOL_DefinedValue = 110,             /* DefinedValue  */
  YYSYMBOL_Number = 111,                   /* Number  */
  YYSYMBOL_ObjectIdentityAssignment = 112, /* ObjectIdentityAssignment  */
  YYSYMBOL_ObjectTypeAssignment = 113,     /* ObjectTypeAssignment  */
  YYSYMBOL_ModuleIdentityAssignment = 114, /* ModuleIdentityAssignment  */
  YYSYMBOL_ImportsAssignment = 115,        /* ImportsAssignment  */
  YYSYMBOL_ExportsAssignment = 116,        /* ExportsAssignment  */
  YYSYMBOL_SnmpRevisionPart = 117,         /* SnmpRevisionPart  */
  YYSYMBOL_SnmpRevisionList = 118,         /* SnmpRevisionList  */
  YYSYMBOL_SnmpRevisionObject = 119,       /* SnmpRevisionObject  */
  YYSYMBOL_SnmpIdentityPart = 120,         /* SnmpIdentityPart  */
  YYSYMBOL_SnmpOrganisationPart = 121,     /* SnmpOrganisationPart  */
  YYSYMBOL_SnmpContactInfoPart = 122,      /* SnmpContactInfoPart  */
  YYSYMBOL_SnmpUpdatePart = 123,           /* SnmpUpdatePart  */
  YYSYMBOL_SnmpDescriptionPart = 124,      /* SnmpDescriptionPart  */
  YYSYMBOL_SnmpDescriptionStatement = 125, /* SnmpDescriptionStatement  */
  YYSYMBOL_ValueConstraint = 126,          /* ValueConstraint  */
  YYSYMBOL_NumericValueConstraintList = 127, /* NumericValueConstraintList  */
  YYSYMBOL_SnmpKeywordAssignment = 128,    /* SnmpKeywordAssignment  */
  YYSYMBOL_SnmpKeywordName = 129,          /* SnmpKeywordName  */
  YYSYMBOL_SnmpKeywordValue = 130,         /* SnmpKeywordValue  */
  YYSYMBOL_SnmpKeywordBinding = 131,       /* SnmpKeywordBinding  */
  YYSYMBOL_SnmpSyntaxPart = 132,           /* SnmpSyntaxPart  */
  YYSYMBOL_SnmpSyntaxStatement = 133,      /* SnmpSyntaxStatement  */
  YYSYMBOL_SnmpUnitsPart = 134,            /* SnmpUnitsPart  */
  YYSYMBOL_SnmpWriteSyntaxPart = 135,      /* SnmpWriteSyntaxPart  */
  YYSYMBOL_SnmpCreationPart = 136,         /* SnmpCreationPart  */
  YYSYMBOL_TypeOrValueAssignment = 137,    /* TypeOrValueAssignment  */
  YYSYMBOL_Type = 138,                     /* Type  */
  YYSYMBOL_NamedType = 139,                /* NamedType  */
  YYSYMBOL_BuiltInType = 140,              /* BuiltInType  */
  YYSYMBOL_BuiltInTypeAssignment = 141,    /* BuiltInTypeAssignment  */
  YYSYMBOL_TypeOrTextualConvention = 142,  /* TypeOrTextualConvention  */
  YYSYMBOL_MacroAssignment = 143,          /* MacroAssignment  */
  YYSYMBOL_TokenList = 144,                /* TokenList  */
  YYSYMBOL_TokenObject = 145,              /* TokenObject  */
  YYSYMBOL_TextualConventionAssignment = 146, /* TextualConventionAssignment  */
  YYSYMBOL_TextualConventionDefinition = 147, /* TextualConventionDefinition  */
  YYSYMBOL_TextualConventionDefinitionElement = 148, /* TextualConventionDefinitionElement  */
  YYSYMBOL_SnmpNotificationTypeAssignment = 149, /* SnmpNotificationTypeAssignment  */
  YYSYMBOL_SnmpTrapVariablePart = 150,     /* SnmpTrapVariablePart  */
  YYSYMBOL_SnmpTrapVariableList = 151,     /* SnmpTrapVariableList  */
  YYSYMBOL_SnmpMandatoryGroupPart = 152,   /* SnmpMandatoryGroupPart  */
  YYSYMBOL_SnmpMandatoryGroupList = 153,   /* SnmpMandatoryGroupList  */
  YYSYMBOL_SnmpMandatoryGroup = 154,       /* SnmpMandatoryGroup  */
  YYSYMBOL_SnmpCompliancePart = 155,       /* SnmpCompliancePart  */
  YYSYMBOL_SnmpComplianceList = 156,       /* SnmpComplianceList  */
  YYSYMBOL_SnmpComplianceObject = 157,     /* SnmpComplianceObject  */
  YYSYMBOL_SnmpObjectsPart = 158,          /* SnmpObjectsPart  */
  YYSYMBOL_SnmpObjectGroupAssignment = 159, /* SnmpObjectGroupAssignment  */
  YYSYMBOL_SnmpNotificationGroupAssignment = 160, /* SnmpNotificationGroupAssignment  */
  YYSYMBOL_ModuleComplianceAssignment = 161, /* ModuleComplianceAssignment  */
  YYSYMBOL_SnmpModuleComplianceList = 162, /* SnmpModuleComplianceList  */
  YYSYMBOL_SnmpModuleComplianceObject = 163, /* SnmpModuleComplianceObject  */
  YYSYMBOL_OptionalModuleName = 164,       /* OptionalModuleName  */
  YYSYMBOL_SnmpVariationsListPart = 165,   /* SnmpVariationsListPart  */
  YYSYMBOL_SnmpVariationsList = 166,       /* SnmpVariationsList  */
  YYSYMBOL_SnmpVariationPart = 167,        /* SnmpVariationPart  */
  YYSYMBOL_ModuleCapabilitiesList = 168,   /* ModuleCapabilitiesList  */
  YYSYMBOL_ModuleCapabilitiesAssignment = 169, /* ModuleCapabilitiesAssignment  */
  YYSYMBOL_AgentCapabilitiesAssignment = 170, /* AgentCapabilitiesAssignment  */
  YYSYMBOL_SnmpAccessPart = 171,           /* SnmpAccessPart  */
  YYSYMBOL_SnmpStatusPart = 172,           /* SnmpStatusPart  */
  YYSYMBOL_SnmpReferencePart = 173,        /* SnmpReferencePart  */
  YYSYMBOL_SnmpReferenceStatement = 174,   /* SnmpReferenceStatement  */
  YYSYMBOL_SnmpDisplayHintStatement = 175, /* SnmpDisplayHintStatement  */
  YYSYMBOL_SnmpIndexPart = 176,            /* SnmpIndexPart  */
  YYSYMBOL_SnmpDefValPart = 177,           /* SnmpDefValPart  */
  YYSYMBOL_DefValList = 178,               /* DefValList  */
  YYSYMBOL_DefValListElement = 179,        /* DefValListElement  */
  YYSYMBOL_BinaryString = 180,             /* BinaryString  */
  YYSYMBOL_HexString = 181,                /* HexString  */
  YYSYMBOL_CharString = 182,               /* CharString  */
  YYSYMBOL_SymbolsFromModuleList = 183,    /* SymbolsFromModuleList  */
  YYSYMBOL_SymbolsFromModule = 184,        /* SymbolsFromModule  */
  YYSYMBOL_SymbolList = 185,               /* SymbolList  */
  YYSYMBOL_Symbol = 186,                   /* Symbol  */
  YYSYMBOL_SequenceItem = 187,             /* SequenceItem  */
  YYSYMBOL_SequenceList = 188,             /* SequenceList  */
  YYSYMBOL_SequenceAssignment = 189,       /* SequenceAssignment  */
  YYSYMBOL_SnmpTypeTagPart = 190,          /* SnmpTypeTagPart  */
  YYSYMBOL_SnmpTypeTagList = 191,          /* SnmpTypeTagList  */
  YYSYMBOL_SnmpTypeTagItem = 192,          /* SnmpTypeTagItem  */
  YYSYMBOL_OctetStringType = 193,          /* OctetStringType  */
  YYSYMBOL_Value = 194,                    /* Value  */
  YYSYMBOL_Identifier = 195,               /* Identifier  */
  YYSYMBOL_UCidentifier = 196,             /* UCidentifier  */
  YYSYMBOL_LCidentifier = 197,             /* LCidentifier  */
  YYSYMBOL_End = 198,                      /* End  */
  YYSYMBOL_Begin = 199                     /* Begin  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   481

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  97
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  103
/* YYNRULES -- Number of rules.  */
#define YYNRULES  226
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  433

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   351


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   258,   258,   259,   263,   264,   268,   272,   276,   280,
     284,   288,   292,   293,   297,   301,   302,   306,   310,   311,
     315,   323,   327,   334,   346,   357,   361,   375,   382,   386,
     394,   401,   408,   418,   419,   423,   424,   431,   432,   433,
     437,   444,   451,   458,   479,   510,   529,   537,   544,   545,
     549,   550,   554,   563,   570,   577,   584,   591,   596,   602,
     609,   610,   611,   615,   616,   617,   623,   624,   625,   629,
     636,   643,   650,   655,   662,   669,   673,   677,   681,   685,
     689,   693,   707,   722,   737,   743,   749,   755,   764,   768,
     772,   776,   783,   792,   796,   800,   804,   808,   812,   816,
     820,   824,   828,   833,   837,   844,   849,   854,   859,   864,
     869,   874,   879,   884,   892,   896,   903,   912,   913,   917,
     921,   929,   930,   934,   935,   936,   948,   949,   967,   989,
    1027,  1028,  1032,  1039,  1040,  1044,  1045,  1049,  1056,  1057,
    1061,  1062,  1066,  1076,  1084,  1088,  1089,  1093,  1094,  1098,
    1117,  1135,  1149,  1150,  1154,  1160,  1164,  1168,  1169,  1173,
    1174,  1178,  1193,  1194,  1198,  1203,  1211,  1232,  1237,  1242,
    1248,  1254,  1277,  1278,  1282,  1289,  1296,  1300,  1304,  1308,
    1309,  1310,  1314,  1318,  1319,  1323,  1327,  1328,  1332,  1336,
    1340,  1347,  1354,  1361,  1365,  1373,  1383,  1387,  1395,  1399,
    1403,  1410,  1418,  1419,  1423,  1427,  1428,  1432,  1433,  1437,
    1444,  1445,  1446,  1447,  1448,  1449,  1450,  1454,  1455,  1456,
    1457,  1464,  1468,  1475,  1482,  1489,  1493
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ENTERPRISE_SYM",
  "TRAP_TYPE_SYM", "VARIABLES_SYM", "EXPLICIT_SYM", "IMPLICIT_SYM",
  "IMPLIED_SYM", "RIGHT_BRACE_SYM", "LEFT_BRACE_SYM", "RIGHT_BRACKET_SYM",
  "LEFT_BRACKET_SYM", "DEFINITIONS_SYM", "ASSIGNMENT_SYM", "BEGIN_SYM",
  "END_SYM", "FROM_SYM", "IMPORTS_SYM", "EXPORTS_SYM", "COMMA_SYM",
  "SEMI_COLON_SYM", "DOT_SYM", "DESCRIPTION_SYM", "ORGANIZATION_SYM",
  "CONTACT_SYM", "UPDATE_SYM", "MODULE_IDENTITY_SYM",
  "MODULE_COMPLIANCE_SYM", "OBJECT_IDENTIFIER_SYM", "OBJECT_TYPE_SYM",
  "OBJECT_GROUP_SYM", "OBJECT_IDENTITY_SYM", "OBJECTS_SYM",
  "MANDATORY_GROUPS_SYM", "GROUP_SYM", "AGENT_CAPABILITIES_SYM",
  "KEYWORD_SYM", "KEYWORD_VALUE_SYM", "KEYWORD_BIND_SYM", "TOKEN_SYM",
  "INTEGER_SYM", "INTEGER32_SYM", "UNSIGNED32_SYM", "GAUGE32_SYM",
  "COUNTER_SYM", "COUNTER32_SYM", "COUNTER64_SYM", "BITS_SYM",
  "STRING_SYM", "OCTET_SYM", "SEQUENCE_SYM", "OF_SYM", "TIMETICKS_SYM",
  "IP_ADDRESS_SYM", "NETWORK_ADDRESS_SYM", "OPAQUE_SYM", "REVISION_SYM",
  "TEXTUAL_CONVENTION_SYM", "ACCESS_SYM", "MAX_ACCESS_SYM",
  "MIN_ACCESS_SYM", "SYNTAX_SYM", "STATUS_SYM", "INDEX_SYM",
  "REFERENCE_SYM", "DEFVAL_SYM", "LEFT_PAREN_SYM", "RIGHT_PAREN_SYM",
  "NOTIFICATIONS_SYM", "NOTIFICATION_GROUP_SYM", "NOTIFICATION_TYPE_SYM",
  "SIZE_SYM", "BAR_SYM", "VARIATION_SYM", "WRITE_SYNTAX_SYM",
  "SUPPORTS_SYM", "INCLUDES_SYM", "CREATION_REQUIRES_SYM",
  "PRODUCT_RELEASE_SYM", "CHOICE_SYM", "UNITS_SYM", "AUGMENTS_SYM",
  "OBJECT_SYM", "TAGS_SYM", "AUTOMATIC_SYM", "MIN_SYM", "MAX_SYM",
  "MODULE_SYM", "MACRO_SYM", "UCASEFIRST_IDENT_SYM",
  "LCASEFIRST_IDENT_SYM", "BSTRING_SYM", "HSTRING_SYM", "CSTRING_SYM",
  "DISPLAY_HINT_SYM", "NUMBER_SYM", "$accept", "ModuleDefinition",
  "AssignmentList", "Assignment", "ModuleIdentifierAssignment",
  "ModuleIdentifier", "ObjectIdentifierAssignment", "AssignedIdentifier",
  "AssignedIdentifierList", "ObjectIdentifierList", "ObjectIdentifier",
  "NumericValue", "NumberOrMinMax", "DefinedValue", "Number",
  "ObjectIdentityAssignment", "ObjectTypeAssignment",
  "ModuleIdentityAssignment", "ImportsAssignment", "ExportsAssignment",
  "SnmpRevisionPart", "SnmpRevisionList", "SnmpRevisionObject",
  "SnmpIdentityPart", "SnmpOrganisationPart", "SnmpContactInfoPart",
  "SnmpUpdatePart", "SnmpDescriptionPart", "SnmpDescriptionStatement",
  "ValueConstraint", "NumericValueConstraintList", "SnmpKeywordAssignment",
  "SnmpKeywordName", "SnmpKeywordValue", "SnmpKeywordBinding",
  "SnmpSyntaxPart", "SnmpSyntaxStatement", "SnmpUnitsPart",
  "SnmpWriteSyntaxPart", "SnmpCreationPart", "TypeOrValueAssignment",
  "Type", "NamedType", "BuiltInType", "BuiltInTypeAssignment",
  "TypeOrTextualConvention", "MacroAssignment", "TokenList", "TokenObject",
  "TextualConventionAssignment", "TextualConventionDefinition",
  "TextualConventionDefinitionElement", "SnmpNotificationTypeAssignment",
  "SnmpTrapVariablePart", "SnmpTrapVariableList", "SnmpMandatoryGroupPart",
  "SnmpMandatoryGroupList", "SnmpMandatoryGroup", "SnmpCompliancePart",
  "SnmpComplianceList", "SnmpComplianceObject", "SnmpObjectsPart",
  "SnmpObjectGroupAssignment", "SnmpNotificationGroupAssignment",
  "ModuleComplianceAssignment", "SnmpModuleComplianceList",
  "SnmpModuleComplianceObject", "OptionalModuleName",
  "SnmpVariationsListPart", "SnmpVariationsList", "SnmpVariationPart",
  "ModuleCapabilitiesList", "ModuleCapabilitiesAssignment",
  "AgentCapabilitiesAssignment", "SnmpAccessPart", "SnmpStatusPart",
  "SnmpReferencePart", "SnmpReferenceStatement",
  "SnmpDisplayHintStatement", "SnmpIndexPart", "SnmpDefValPart",
  "DefValList", "DefValListElement", "BinaryString", "HexString",
  "CharString", "SymbolsFromModuleList", "SymbolsFromModule", "SymbolList",
  "Symbol", "SequenceItem", "SequenceList", "SequenceAssignment",
  "SnmpTypeTagPart", "SnmpTypeTagList", "SnmpTypeTagItem",
  "OctetStringType", "Value", "Identifier", "UCidentifier", "LCidentifier",
  "End", "Begin", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351
};
#endif

#define YYPACT_NINF (-346)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-223)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -38,  -346,    73,   390,  -346,    66,  -346,  -346,    41,    41,
      50,    69,   112,   124,   162,   167,   183,   211,   216,   228,
     231,  -346,   390,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
     140,  -346,   104,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
    -346,    27,   232,   195,  -346,   240,   136,    26,  -346,   168,
    -346,  -346,  -346,   200,   158,    14,    14,    14,    14,    14,
      14,    14,    14,    14,   241,  -346,  -346,   158,   236,   247,
     250,  -346,   254,   263,   256,   242,   246,    13,   155,    18,
    -346,   246,    13,   226,    13,  -346,    -4,  -346,  -346,  -346,
     -38,    41,  -346,  -346,  -346,   -38,   258,   176,  -346,    23,
      23,  -346,  -346,   349,   299,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,   275,  -346,   158,   291,   158,
     307,  -346,   136,    19,  -346,    24,   237,  -346,   136,   296,
     310,   311,   213,   126,   312,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,   185,   312,  -346,  -346,   296,
     246,   158,   246,   243,  -346,  -346,  -346,   229,   299,   158,
     158,   158,  -346,  -346,   176,  -346,  -346,  -346,  -346,   192,
     172,  -346,  -346,   274,    17,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,   277,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,    46,  -346,  -346,   158,   296,
    -346,    41,   323,  -346,   158,   213,  -346,   264,  -346,    29,
      32,   136,   136,   136,   246,   212,  -346,  -346,    16,  -346,
    -346,  -346,   266,   308,   267,  -346,   264,   296,   246,   296,
     241,   325,  -346,   212,  -346,  -346,  -346,  -346,  -346,  -346,
      28,   316,  -346,  -346,   330,   273,   276,   278,   292,  -346,
     293,  -346,  -346,  -346,  -346,   287,    51,   335,   296,  -346,
    -346,   246,   256,  -346,  -346,   130,  -346,   152,  -346,  -346,
    -346,   296,  -346,   154,    24,  -346,  -346,   229,   136,   259,
     264,   296,   264,  -346,  -346,   192,   192,   326,  -346,   109,
     192,  -346,  -346,  -346,   158,   256,   287,  -346,  -346,    41,
     264,   296,  -346,  -346,  -346,   264,  -346,   212,  -346,   282,
    -346,   -38,     6,  -346,   256,   264,   256,  -346,  -346,   109,
     284,   286,   296,  -346,  -346,   164,   256,   264,   256,  -346,
    -346,   327,  -346,  -346,  -346,  -346,    72,  -346,  -346,  -346,
     294,  -346,  -346,  -346,    77,  -346,   353,     9,   327,  -346,
     -38,   288,    21,  -346,  -346,   354,   356,   301,    41,   136,
     136,  -346,     9,  -346,  -346,   295,    41,  -346,  -346,    41,
     212,   358,   256,   166,   296,   242,  -346,   360,     4,   170,
     364,   308,  -346,    64,  -346,  -346,  -346,  -346,   300,    41,
     136,  -346,   302,  -346,  -346,  -346,    34,   365,   357,   370,
     372,   376,    10,    24,   213,   173,   242,  -346,  -346,   174,
    -346,   378,  -346,  -346,  -346,  -346,  -346,   296,   302,   300,
    -346,  -346,  -346,  -346,   213,   320,   391,   301,    41,   296,
     220,  -346,  -346
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   223,     0,     0,    20,     0,     1,   225,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,     5,     6,     7,     8,    17,    18,    19,
       0,    15,    66,    10,    81,     9,    11,    14,    13,    12,
      16,     0,   221,   222,     3,     0,     0,     0,   194,     0,
     197,   198,   199,     0,     0,   206,   206,   206,   206,   206,
     206,   206,   206,   206,     0,     4,     2,     0,     0,     0,
       0,    67,     0,     0,     0,    73,     0,   148,   206,     0,
      53,     0,   148,     0,   148,    24,     0,   200,    46,   193,
       0,     0,    47,   192,    69,     0,     0,     0,   114,    89,
      88,   107,   115,     0,   205,   208,   108,   113,   110,   111,
     112,   109,   105,   106,   226,     0,    56,     0,     0,     0,
       0,    68,     0,     0,    23,   206,    76,    72,     0,    58,
       0,     0,   170,     0,     0,   190,   191,    42,   217,    83,
      82,   219,   218,   220,    87,     0,     0,    25,    26,    58,
       0,     0,     0,     0,    21,   195,   196,     0,   206,     0,
       0,     0,   125,   127,   120,   122,   124,   126,   123,     0,
       0,    91,    90,     0,     0,   103,    93,    95,    96,   100,
      97,    98,    99,   216,     0,   101,   213,   214,   215,   104,
      92,   221,   222,   207,   119,     0,   118,    54,     0,    58,
      70,     0,   131,    74,     0,   170,   171,   173,    57,     0,
       0,     0,     0,     0,     0,     0,    84,    86,     0,    29,
      31,    30,     0,   221,    41,    85,   173,    58,     0,    58,
       0,     0,   102,     0,    59,   174,   175,   121,    38,    39,
      65,    33,    34,    37,     0,     0,     0,     0,     0,    94,
       0,   210,   117,   116,    55,    49,     0,     0,    58,   130,
      75,     0,     0,   172,   145,     0,   147,     0,   167,   168,
     169,    58,   202,     0,   206,    27,    28,     0,     0,     0,
     173,    58,   173,    22,   209,     0,     0,     0,    62,     0,
       0,    60,   211,   212,     0,     0,    48,    51,    71,     0,
     173,    58,    43,   144,   146,   173,   204,     0,   201,     0,
      40,   156,     0,   153,     0,   173,     0,    64,    63,     0,
       0,     0,    58,    45,    50,     0,     0,   173,     0,   203,
      32,   134,   155,   151,   152,   149,     0,   150,    35,    36,
       0,    52,   132,   129,   178,   128,     0,   139,   133,   136,
       0,     0,     0,   163,    61,     0,     0,   185,     0,     0,
       0,   154,   138,   141,   135,     0,     0,   166,   162,     0,
       0,     0,     0,     0,    58,    73,   140,     0,   158,     0,
       0,     0,    41,     0,   184,    44,   137,   143,    78,     0,
       0,   165,   157,   160,   176,   177,     0,     0,   187,     0,
       0,     0,     0,   206,   170,     0,    73,   159,   189,     0,
     183,     0,   179,   180,   181,   182,    77,    58,   158,    78,
     188,   186,   142,   164,   170,    80,     0,   185,     0,    58,
       0,   161,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -346,  -346,  -346,   385,  -346,   386,  -346,   -59,    39,  -346,
     182,  -346,  -239,  -133,   -69,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,   115,  -346,  -346,  -346,  -346,   -94,   -80,   313,
    -156,  -346,  -346,   340,  -346,  -345,   -65,  -346,    -5,  -346,
    -346,   -72,   257,  -346,  -346,   238,  -346,  -346,   221,   339,
    -346,   260,  -346,  -346,  -346,  -346,  -346,    70,  -346,  -346,
      58,   107,  -346,  -346,  -346,  -346,   110,  -346,     3,  -346,
      31,  -346,    74,  -346,  -200,   -63,  -187,   -27,  -346,  -346,
      -2,    20,  -346,    45,    47,   -51,  -346,   382,    -9,   347,
     134,  -346,   -83,   289,  -346,   338,  -346,  -346,     0,     1,
      -1,   -15,   -78
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,    22,    23,     3,   351,    24,    85,   147,   218,
     219,   240,   241,   242,   243,    25,    26,    27,    28,    29,
     295,   296,   297,    30,   118,   199,    68,   207,   208,   171,
     244,    31,    32,    71,    72,   126,   127,   205,   404,   427,
      33,    98,    99,   100,    34,   101,    35,   195,   196,   102,
     164,   165,    36,   258,   259,   347,   348,   349,   361,   362,
     363,   132,    37,    38,    39,   312,   313,   331,   391,   392,
     393,   352,   353,    40,   214,   166,   262,   263,   168,   357,
     372,   397,   398,   141,   142,    94,    47,    48,    49,    50,
     272,   273,   216,   103,   104,   105,   189,   144,   245,    51,
      52,    44,   115
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      53,     5,    43,    41,    42,   261,   139,    66,   154,   138,
     148,   114,   220,   129,   247,   124,   116,   162,   149,   415,
     123,    43,    41,    42,    91,   275,    95,   143,   145,   145,
     388,    73,   163,   169,    46,   123,    95,    46,   264,   279,
      46,   266,    46,   408,   359,    87,   130,    88,   285,    46,
     320,   217,     1,   203,   148,   226,    74,    75,   249,    76,
     298,   419,     7,   225,    54,    96,   197,   250,   200,   146,
     167,    91,    97,     6,   396,    96,   221,   277,   390,    45,
     338,   153,   131,    55,   162,   220,   194,   227,   231,   229,
     170,   155,   360,   314,   311,   316,   157,   350,    77,   163,
     228,   286,   192,   190,   191,   255,     1,    21,   234,   235,
     236,     1,   137,   326,   137,   137,     1,    21,   328,     1,
      21,   202,     1,    21,     1,    21,    56,   206,   336,   317,
     318,     1,    21,   280,   321,   282,   215,   167,    57,   303,
     344,   355,    69,    70,   224,   222,   223,   254,   350,   221,
      91,   271,   283,   260,     1,    21,   135,   136,    93,   356,
     137,   304,     1,   306,   300,   281,    67,    95,   224,   224,
     223,   223,    91,   342,   307,   386,    58,   305,   158,   394,
     253,    59,   418,   420,    91,    90,    91,   315,    91,   150,
      91,   152,   256,    91,    91,   238,   239,    60,   301,   159,
     265,   267,   308,   302,   417,   137,   133,   327,   309,    79,
     268,   269,   270,    97,   192,   274,   191,   224,   222,   223,
      91,    92,    80,    81,   425,    61,    82,    21,   341,   432,
      62,    83,   192,   190,   191,   134,   323,   380,   125,   128,
      91,   160,    63,   322,   246,    64,    78,   135,   136,    93,
     220,   137,    93,   333,    86,   335,   114,   337,   238,   239,
     117,   119,     1,    21,   120,    84,   122,   343,   137,   345,
     123,   161,   211,   212,   213,     1,    21,   310,   238,   239,
     387,   137,     1,    21,   224,   224,   223,   223,   137,   224,
     325,   223,    69,   367,   106,   107,   108,   109,   110,   111,
     112,   113,     1,    21,   125,   151,   192,   274,   191,   128,
     158,    95,   332,   385,   221,   194,   198,   201,   204,   159,
     209,   210,   215,   422,   248,   137,   251,   230,   257,   160,
     278,   416,   401,   277,  -222,   431,   284,     5,   287,   288,
     289,   292,   293,   290,   294,   299,   291,   311,   319,   373,
     330,   365,   339,     5,   340,   173,   174,   378,   374,   375,
     379,   346,   354,   358,   369,   366,   370,   371,   383,   382,
     389,   381,   377,   395,   410,   403,   390,   411,   175,   412,
     405,   413,   224,   402,   223,   414,     4,   409,   396,   406,
     176,   177,   178,   179,   180,   181,   182,   183,   426,   184,
     276,   428,   185,   186,   187,   188,     7,    65,     8,     9,
     384,   324,   121,   172,   424,   232,   252,   140,   364,   430,
     376,   423,   334,   407,   237,   429,   368,    10,   399,    89,
     400,   421,    11,    12,    13,    14,    15,    16,   156,     1,
      21,   329,   193,    17,    18,     0,    19,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       1,    21
};

static const yytype_int16 yycheck[] =
{
       9,     0,     3,     3,     3,   205,    78,    22,    86,    78,
      79,    15,   145,    76,   170,    74,    67,    97,    81,     9,
      14,    22,    22,    22,    20,     9,    12,    78,    10,    10,
     375,     4,    97,    10,     8,    14,    12,     8,     9,   226,
       8,     9,     8,     9,    35,    46,    33,    21,    20,     8,
     289,   134,    90,   125,   123,   149,    29,    30,    41,    32,
       9,   406,    16,   146,    14,    51,   117,    50,   119,    51,
      97,    20,    58,     0,    10,    51,   145,    67,    74,    13,
     319,    85,    69,    14,   164,   218,    40,   150,   157,   152,
      67,    90,    83,   280,    88,   282,    95,    76,    71,   164,
     151,    73,   103,   103,   103,   199,    90,    91,   159,   160,
     161,    90,    96,   300,    96,    96,    90,    91,   305,    90,
      91,   122,    90,    91,    90,    91,    14,   128,   315,   285,
     286,    90,    91,   227,   290,   229,    10,   164,    14,     9,
     327,    64,    38,    39,   145,   145,   145,   198,    76,   218,
      20,   214,   230,   204,    90,    91,    92,    93,    94,    82,
      96,     9,    90,     9,   258,   228,    26,    12,   169,   170,
     169,   170,    20,     9,    20,     9,    14,   271,    52,     9,
     195,    14,     9,     9,    20,    17,    20,   281,    20,    82,
      20,    84,   201,    20,    20,    86,    87,    14,   261,    23,
     209,   210,   274,   262,   404,    96,    51,   301,   277,    14,
     211,   212,   213,    58,   215,   215,   215,   218,   218,   218,
      20,    21,    27,    28,   424,    14,    31,    91,   322,     9,
      14,    36,   233,   233,   233,    80,   295,   370,    62,    63,
      20,    65,    14,   294,    72,    14,    14,    92,    93,    94,
     383,    96,    94,   312,    14,   314,    15,   316,    86,    87,
      24,    14,    90,    91,    14,    70,     3,   326,    96,   328,
      14,    95,    59,    60,    61,    90,    91,   278,    86,    87,
     374,    96,    90,    91,   285,   286,   285,   286,    96,   290,
     299,   290,    38,   352,    56,    57,    58,    59,    60,    61,
      62,    63,    90,    91,    62,    79,   307,   307,   307,    63,
      52,    12,   311,   372,   383,    40,    25,    10,    81,    23,
      10,    10,    10,   417,    50,    96,    49,    84,     5,    65,
      22,   403,   383,    67,    67,   429,    11,   336,    22,     9,
      67,    49,    49,    67,    57,    10,    68,    88,    22,   358,
      68,   350,    68,   352,    68,     6,     7,   366,   359,   360,
     369,    34,    68,    10,    10,    77,    10,    66,    10,   370,
      10,   370,    77,     9,     9,    75,    74,    20,    29,     9,
     389,     9,   383,   383,   383,     9,     0,   396,    10,   390,
      41,    42,    43,    44,    45,    46,    47,    48,    78,    50,
     218,    10,    53,    54,    55,    56,    16,    22,    18,    19,
     371,   296,    72,   100,   419,   158,   195,    78,   348,   428,
     362,   418,   312,   392,   164,   427,   352,    37,   383,    47,
     383,   411,    42,    43,    44,    45,    46,    47,    91,    90,
      91,   307,   104,    53,    54,    -1,    56,   158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    91
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    90,    98,   101,   102,   196,     0,    16,    18,    19,
      37,    42,    43,    44,    45,    46,    47,    53,    54,    56,
      89,    91,    99,   100,   103,   112,   113,   114,   115,   116,
     120,   128,   129,   137,   141,   143,   149,   159,   160,   161,
     170,   195,   196,   197,   198,    13,     8,   183,   184,   185,
     186,   196,   197,   185,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,   100,   198,    26,   123,    38,
      39,   130,   131,     4,    29,    30,    32,    71,    14,    14,
      27,    28,    31,    36,    70,   104,    14,   197,    21,   184,
      17,    20,    21,    94,   182,    12,    51,    58,   138,   139,
     140,   142,   146,   190,   191,   192,   142,   142,   142,   142,
     142,   142,   142,   142,    15,   199,   182,    24,   121,    14,
      14,   130,     3,    14,   104,    62,   132,   133,    63,   172,
      33,    69,   158,    51,    80,    92,    93,    96,   111,   138,
     146,   180,   181,   182,   194,    10,    51,   105,   111,   172,
     158,    79,   158,    85,   199,   196,   186,   196,    52,    23,
      65,    95,   125,   133,   147,   148,   172,   174,   175,    10,
      67,   126,   126,     6,     7,    29,    41,    42,    43,    44,
      45,    46,    47,    48,    50,    53,    54,    55,    56,   193,
     195,   196,   197,   192,    40,   144,   145,   182,    25,   122,
     182,    10,   197,   138,    81,   134,   197,   124,   125,    10,
      10,    59,    60,    61,   171,    10,   189,   189,   106,   107,
     110,   111,   195,   196,   197,   189,   124,   172,   182,   172,
      84,   111,   139,   190,   182,   182,   182,   148,    86,    87,
     108,   109,   110,   111,   127,   195,    72,   127,    50,    41,
      50,    49,   145,   198,   182,   124,   185,     5,   150,   151,
     182,   171,   173,   174,     9,   185,     9,   185,   197,   197,
     197,   172,   187,   188,   195,     9,   107,    67,    22,   173,
     124,   172,   124,   199,    11,    20,    73,    22,     9,    67,
      67,    68,    49,    49,    57,   117,   118,   119,     9,    10,
     124,   172,   104,     9,     9,   124,     9,    20,   138,   111,
     197,    88,   162,   163,   173,   124,   173,   127,   127,    22,
     109,   127,   182,   104,   119,   185,   173,   124,   173,   187,
      68,   164,   196,   104,   163,   104,   173,   104,   109,    68,
      68,   124,     9,   104,   173,   104,    34,   152,   153,   154,
      76,   102,   168,   169,    68,    64,    82,   176,    10,    35,
      83,   155,   156,   157,   154,   196,    77,   104,   169,    10,
      10,    66,   177,   185,   197,   197,   157,    77,   185,   185,
     110,   196,   197,    10,   105,   104,     9,   124,   132,    10,
      74,   165,   166,   167,     9,     9,    10,   178,   179,   180,
     181,   182,   195,    75,   135,   185,   197,   167,     9,   185,
       9,    20,     9,     9,     9,     9,   138,   171,     9,   132,
       9,   178,   124,   165,   135,   171,    78,   136,    10,   177,
     185,   124,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    97,    98,    98,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     101,   102,   102,   103,   103,   104,   104,   105,   106,   106,
     107,   107,   107,   108,   108,   108,   108,   109,   109,   109,
     110,   110,   111,   112,   113,   114,   115,   116,   117,   117,
     118,   118,   119,   120,   121,   122,   123,   124,   124,   125,
     126,   126,   126,   127,   127,   127,   128,   128,   128,   129,
     130,   131,   132,   132,   133,   134,   134,   135,   135,   136,
     136,   137,   137,   137,   137,   137,   137,   137,   138,   138,
     138,   138,   139,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   142,   142,   143,   144,   144,   145,
     146,   147,   147,   148,   148,   148,   148,   148,   149,   149,
     150,   150,   151,   152,   152,   153,   153,   154,   155,   155,
     156,   156,   157,   157,   158,   158,   158,   158,   158,   159,
     160,   161,   162,   162,   163,   164,   164,   165,   165,   166,
     166,   167,   168,   168,   169,   169,   170,   171,   171,   171,
     171,   172,   173,   173,   174,   175,   176,   176,   176,   177,
     177,   177,   177,   177,   177,   177,   178,   178,   179,   179,
     180,   181,   182,   183,   183,   184,   185,   185,   186,   186,
     186,   187,   188,   188,   189,   190,   190,   191,   191,   192,
     193,   193,   193,   193,   193,   193,   193,   194,   194,   194,
     194,   195,   195,   196,   197,   198,   199
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     6,     3,     2,     2,     2,     3,     2,     1,
       1,     1,     4,     1,     1,     4,     4,     1,     1,     1,
       3,     1,     1,     6,    11,     7,     3,     3,     1,     0,
       2,     1,     3,     2,     2,     2,     2,     1,     0,     2,
       3,     6,     3,     3,     3,     1,     1,     2,     3,     3,
       3,     5,     1,     0,     2,     2,     0,     2,     0,     4,
       0,     1,     3,     3,     4,     4,     4,     3,     1,     1,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     5,     2,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     8,     8,
       1,     0,     4,     1,     0,     2,     1,     4,     1,     0,
       2,     1,     6,     3,     4,     3,     4,     3,     0,     7,
       7,     7,     2,     1,     4,     1,     0,     1,     0,     2,
       1,     8,     2,     1,     7,     4,     9,     2,     2,     2,
       0,     2,     1,     0,     2,     2,     4,     4,     0,     4,
       4,     4,     4,     4,     2,     0,     3,     1,     3,     2,
       1,     1,     1,     2,     1,     3,     3,     1,     1,     1,
       2,     2,     1,     3,     3,     1,     0,     2,     1,     4,
       2,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* Assignment: ObjectIdentifierAssignment  */
#line 269 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1756 "parser.tab.cpp"
    break;

  case 7: /* Assignment: ObjectIdentityAssignment  */
#line 273 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1764 "parser.tab.cpp"
    break;

  case 8: /* Assignment: ObjectTypeAssignment  */
#line 277 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1772 "parser.tab.cpp"
    break;

  case 9: /* Assignment: MacroAssignment  */
#line 281 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1780 "parser.tab.cpp"
    break;

  case 10: /* Assignment: TypeOrValueAssignment  */
#line 285 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1788 "parser.tab.cpp"
    break;

  case 11: /* Assignment: SnmpNotificationTypeAssignment  */
#line 289 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1796 "parser.tab.cpp"
    break;

  case 13: /* Assignment: SnmpNotificationGroupAssignment  */
#line 294 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1804 "parser.tab.cpp"
    break;

  case 14: /* Assignment: SnmpObjectGroupAssignment  */
#line 298 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1812 "parser.tab.cpp"
    break;

  case 16: /* Assignment: AgentCapabilitiesAssignment  */
#line 303 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1820 "parser.tab.cpp"
    break;

  case 17: /* Assignment: ModuleIdentityAssignment  */
#line 307 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1828 "parser.tab.cpp"
    break;

  case 20: /* ModuleIdentifierAssignment: ModuleIdentifier  */
#line 316 "parser.y"
{
   m_pModule = new MP_MODULE;
   m_pModule->pszName = (yyvsp[0].pszString);
}
#line 1837 "parser.tab.cpp"
    break;

  case 21: /* ModuleIdentifier: UCidentifier DEFINITIONS_SYM ASSIGNMENT_SYM Begin  */
#line 324 "parser.y"
{
   (yyval.pszString) = (yyvsp[-3].pszString);
}
#line 1845 "parser.tab.cpp"
    break;

  case 22: /* ModuleIdentifier: UCidentifier DEFINITIONS_SYM ASSIGNMENT_SYM AUTOMATIC_SYM TAGS_SYM Begin  */
#line 328 "parser.y"
{
   (yyval.pszString) = (yyvsp[-5].pszString);
}
#line 1853 "parser.tab.cpp"
    break;

  case 23: /* ObjectIdentifierAssignment: Identifier OBJECT_IDENTIFIER_SYM AssignedIdentifier  */
#line 335 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 1869 "parser.tab.cpp"
    break;

  case 24: /* ObjectIdentifierAssignment: LCidentifier AssignedIdentifier  */
#line 347 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-1].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 1881 "parser.tab.cpp"
    break;

  case 25: /* AssignedIdentifier: ASSIGNMENT_SYM AssignedIdentifierList  */
#line 358 "parser.y"
{
   (yyval.pOID) = (yyvsp[0].pOID);
}
#line 1889 "parser.tab.cpp"
    break;

  case 26: /* AssignedIdentifier: ASSIGNMENT_SYM Number  */
#line 362 "parser.y"
{
   MP_SUBID *subid;

   subid = new MP_SUBID;
   subid->dwValue = (yyvsp[0].number).value.nInt32;
   subid->pszName = NULL;
   subid->bResolved = TRUE;
   (yyval.pOID) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.pOID)->add(subid);
}
#line 1904 "parser.tab.cpp"
    break;

  case 27: /* AssignedIdentifierList: LEFT_BRACE_SYM ObjectIdentifierList RIGHT_BRACE_SYM  */
#line 376 "parser.y"
{
   (yyval.pOID) = (yyvsp[-1].pOID);
}
#line 1912 "parser.tab.cpp"
    break;

  case 28: /* ObjectIdentifierList: ObjectIdentifierList ObjectIdentifier  */
#line 383 "parser.y"
{
   (yyval.pOID)->add((yyvsp[0].pSubId));
}
#line 1920 "parser.tab.cpp"
    break;

  case 29: /* ObjectIdentifierList: ObjectIdentifier  */
#line 387 "parser.y"
{
   (yyval.pOID) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.pOID)->add((yyvsp[0].pSubId));
}
#line 1929 "parser.tab.cpp"
    break;

  case 30: /* ObjectIdentifier: Number  */
#line 395 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[0].number).value.nInt32;
   (yyval.pSubId)->pszName = NULL;
   (yyval.pSubId)->bResolved = TRUE;
}
#line 1940 "parser.tab.cpp"
    break;

  case 31: /* ObjectIdentifier: DefinedValue  */
#line 402 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = 0;
   (yyval.pSubId)->pszName = (yyvsp[0].pszString);
   (yyval.pSubId)->bResolved = FALSE;
}
#line 1951 "parser.tab.cpp"
    break;

  case 32: /* ObjectIdentifier: Identifier LEFT_PAREN_SYM Number RIGHT_PAREN_SYM  */
#line 409 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[-1].number).value.nInt32;
   (yyval.pSubId)->pszName = (yyvsp[-3].pszString);
   (yyval.pSubId)->bResolved = TRUE;
}
#line 1962 "parser.tab.cpp"
    break;

  case 34: /* NumericValue: DefinedValue  */
#line 420 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 1970 "parser.tab.cpp"
    break;

  case 36: /* NumericValue: Identifier LEFT_PAREN_SYM NumberOrMinMax RIGHT_PAREN_SYM  */
#line 425 "parser.y"
{
   MemFree((yyvsp[-3].pszString));
}
#line 1978 "parser.tab.cpp"
    break;

  case 40: /* DefinedValue: UCidentifier DOT_SYM LCidentifier  */
#line 438 "parser.y"
{
   (yyval.pszString) = (char *)MemAlloc(strlen((yyvsp[-2].pszString)) + strlen((yyvsp[0].pszString)) + 2);
   sprintf((yyval.pszString), "%s.%s", (yyvsp[-2].pszString), (yyvsp[0].pszString));
   MemFree((yyvsp[-2].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 1989 "parser.tab.cpp"
    break;

  case 41: /* DefinedValue: LCidentifier  */
#line 445 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 1997 "parser.tab.cpp"
    break;

  case 42: /* Number: NUMBER_SYM  */
#line 452 "parser.y"
{
   (yyval.number) = (yyvsp[0].number);
}
#line 2005 "parser.tab.cpp"
    break;

  case 43: /* ObjectIdentityAssignment: Identifier OBJECT_IDENTITY_SYM SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 463 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-5].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2023 "parser.tab.cpp"
    break;

  case 44: /* ObjectTypeAssignment: Identifier OBJECT_TYPE_SYM SnmpSyntaxPart SnmpUnitsPart SnmpAccessPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart SnmpIndexPart SnmpDefValPart AssignedIdentifier  */
#line 489 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-10].pszString);
   (yyval.pObject)->iSyntax = (yyvsp[-8].pSyntax)->nSyntax;
   (yyval.pObject)->pszDataType = (yyvsp[-8].pSyntax)->pszStr;
   (yyvsp[-8].pSyntax)->pszStr = NULL;
   delete (yyvsp[-8].pSyntax);
   (yyval.pObject)->iAccess = (yyvsp[-6].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-5].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-4].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2046 "parser.tab.cpp"
    break;

  case 45: /* ModuleIdentityAssignment: SnmpIdentityPart SnmpUpdatePart SnmpOrganisationPart SnmpContactInfoPart SnmpDescriptionPart SnmpRevisionPart AssignedIdentifier  */
#line 517 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->iSyntax = MIB_TYPE_MODID;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2060 "parser.tab.cpp"
    break;

  case 46: /* ImportsAssignment: IMPORTS_SYM SymbolsFromModuleList SEMI_COLON_SYM  */
#line 530 "parser.y"
{
	delete m_pModule->pImportList;
   m_pModule->pImportList = (yyvsp[-1].pImportList);
}
#line 2069 "parser.tab.cpp"
    break;

  case 47: /* ExportsAssignment: EXPORTS_SYM SymbolList SEMI_COLON_SYM  */
#line 538 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2077 "parser.tab.cpp"
    break;

  case 52: /* SnmpRevisionObject: REVISION_SYM CharString SnmpDescriptionPart  */
#line 556 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2086 "parser.tab.cpp"
    break;

  case 53: /* SnmpIdentityPart: LCidentifier MODULE_IDENTITY_SYM  */
#line 564 "parser.y"
{
   (yyval.pszString) = (yyvsp[-1].pszString);
}
#line 2094 "parser.tab.cpp"
    break;

  case 54: /* SnmpOrganisationPart: ORGANIZATION_SYM CharString  */
#line 571 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2102 "parser.tab.cpp"
    break;

  case 55: /* SnmpContactInfoPart: CONTACT_SYM CharString  */
#line 578 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2110 "parser.tab.cpp"
    break;

  case 56: /* SnmpUpdatePart: UPDATE_SYM CharString  */
#line 585 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2118 "parser.tab.cpp"
    break;

  case 57: /* SnmpDescriptionPart: SnmpDescriptionStatement  */
#line 592 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2126 "parser.tab.cpp"
    break;

  case 58: /* SnmpDescriptionPart: %empty  */
#line 596 "parser.y"
{
   (yyval.pszString) = nullptr;
}
#line 2134 "parser.tab.cpp"
    break;

  case 59: /* SnmpDescriptionStatement: DESCRIPTION_SYM CharString  */
#line 603 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2142 "parser.tab.cpp"
    break;

  case 65: /* NumericValueConstraintList: NumericValue  */
#line 618 "parser.y"
{
}
#line 2149 "parser.tab.cpp"
    break;

  case 69: /* SnmpKeywordName: KEYWORD_SYM ASSIGNMENT_SYM CharString  */
#line 630 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2157 "parser.tab.cpp"
    break;

  case 70: /* SnmpKeywordValue: KEYWORD_VALUE_SYM ASSIGNMENT_SYM CharString  */
#line 637 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2165 "parser.tab.cpp"
    break;

  case 71: /* SnmpKeywordBinding: KEYWORD_BIND_SYM ASSIGNMENT_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 644 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2173 "parser.tab.cpp"
    break;

  case 72: /* SnmpSyntaxPart: SnmpSyntaxStatement  */
#line 651 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2181 "parser.tab.cpp"
    break;

  case 73: /* SnmpSyntaxPart: %empty  */
#line 655 "parser.y"
{
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = MIB_TYPE_OTHER;
}
#line 2190 "parser.tab.cpp"
    break;

  case 74: /* SnmpSyntaxStatement: SYNTAX_SYM Type  */
#line 663 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2198 "parser.tab.cpp"
    break;

  case 75: /* SnmpUnitsPart: UNITS_SYM CharString  */
#line 670 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2206 "parser.tab.cpp"
    break;

  case 77: /* SnmpWriteSyntaxPart: WRITE_SYNTAX_SYM Type  */
#line 678 "parser.y"
{
	delete (yyvsp[0].pSyntax);
}
#line 2214 "parser.tab.cpp"
    break;

  case 79: /* SnmpCreationPart: CREATION_REQUIRES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 686 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2222 "parser.tab.cpp"
    break;

  case 81: /* TypeOrValueAssignment: BuiltInTypeAssignment  */
#line 694 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->pszName = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2240 "parser.tab.cpp"
    break;

  case 82: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM TextualConventionAssignment  */
#line 708 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TEXTUAL_CONVENTION;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2259 "parser.tab.cpp"
    break;

  case 83: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM Type  */
#line 723 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2278 "parser.tab.cpp"
    break;

  case 84: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM SEQUENCE_SYM SequenceAssignment  */
#line 738 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2288 "parser.tab.cpp"
    break;

  case 85: /* TypeOrValueAssignment: LCidentifier ASSIGNMENT_SYM SEQUENCE_SYM SequenceAssignment  */
#line 744 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2298 "parser.tab.cpp"
    break;

  case 86: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM CHOICE_SYM SequenceAssignment  */
#line 750 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_CHOICE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2308 "parser.tab.cpp"
    break;

  case 87: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM Value  */
#line 756 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_VALUE;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
}
#line 2318 "parser.tab.cpp"
    break;

  case 88: /* Type: BuiltInType  */
#line 765 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2326 "parser.tab.cpp"
    break;

  case 89: /* Type: NamedType  */
#line 769 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2334 "parser.tab.cpp"
    break;

  case 90: /* Type: BuiltInType ValueConstraint  */
#line 773 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2342 "parser.tab.cpp"
    break;

  case 91: /* Type: NamedType ValueConstraint  */
#line 777 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2350 "parser.tab.cpp"
    break;

  case 92: /* NamedType: SnmpTypeTagPart Identifier  */
#line 784 "parser.y"
{
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = -1;
   (yyval.pSyntax)->pszStr = (yyvsp[0].pszString);
}
#line 2360 "parser.tab.cpp"
    break;

  case 93: /* BuiltInType: SnmpTypeTagPart INTEGER_SYM  */
#line 793 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2368 "parser.tab.cpp"
    break;

  case 94: /* BuiltInType: SnmpTypeTagPart IMPLICIT_SYM INTEGER_SYM  */
#line 797 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2376 "parser.tab.cpp"
    break;

  case 95: /* BuiltInType: SnmpTypeTagPart INTEGER32_SYM  */
#line 801 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
}
#line 2384 "parser.tab.cpp"
    break;

  case 96: /* BuiltInType: SnmpTypeTagPart UNSIGNED32_SYM  */
#line 805 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
}
#line 2392 "parser.tab.cpp"
    break;

  case 97: /* BuiltInType: SnmpTypeTagPart COUNTER_SYM  */
#line 809 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
}
#line 2400 "parser.tab.cpp"
    break;

  case 98: /* BuiltInType: SnmpTypeTagPart COUNTER32_SYM  */
#line 813 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
}
#line 2408 "parser.tab.cpp"
    break;

  case 99: /* BuiltInType: SnmpTypeTagPart COUNTER64_SYM  */
#line 817 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
}
#line 2416 "parser.tab.cpp"
    break;

  case 100: /* BuiltInType: SnmpTypeTagPart GAUGE32_SYM  */
#line 821 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
}
#line 2424 "parser.tab.cpp"
    break;

  case 101: /* BuiltInType: SnmpTypeTagPart TIMETICKS_SYM  */
#line 825 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
}
#line 2432 "parser.tab.cpp"
    break;

  case 102: /* BuiltInType: SEQUENCE_SYM OF_SYM NamedType  */
#line 829 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_SEQUENCE);
   delete (yyvsp[0].pSyntax);
}
#line 2441 "parser.tab.cpp"
    break;

  case 103: /* BuiltInType: SnmpTypeTagPart OBJECT_IDENTIFIER_SYM  */
#line 834 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OBJID);
}
#line 2449 "parser.tab.cpp"
    break;

  case 104: /* BuiltInType: SnmpTypeTagPart OctetStringType  */
#line 838 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OCTETSTR);
}
#line 2457 "parser.tab.cpp"
    break;

  case 105: /* BuiltInTypeAssignment: IP_ADDRESS_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 845 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_IPADDR);
   (yyval.pSyntax)->pszStr = MemCopyStringA("IpAddress");
}
#line 2466 "parser.tab.cpp"
    break;

  case 106: /* BuiltInTypeAssignment: OPAQUE_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 850 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OPAQUE);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Opaque");
}
#line 2475 "parser.tab.cpp"
    break;

  case 107: /* BuiltInTypeAssignment: INTEGER32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 855 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Integer32");
}
#line 2484 "parser.tab.cpp"
    break;

  case 108: /* BuiltInTypeAssignment: UNSIGNED32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 860 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Unsigned32");
}
#line 2493 "parser.tab.cpp"
    break;

  case 109: /* BuiltInTypeAssignment: TIMETICKS_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 865 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
   (yyval.pSyntax)->pszStr = MemCopyStringA("TimeTicks");
}
#line 2502 "parser.tab.cpp"
    break;

  case 110: /* BuiltInTypeAssignment: COUNTER_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 870 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter");
}
#line 2511 "parser.tab.cpp"
    break;

  case 111: /* BuiltInTypeAssignment: COUNTER32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 875 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter32");
}
#line 2520 "parser.tab.cpp"
    break;

  case 112: /* BuiltInTypeAssignment: COUNTER64_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 880 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter64");
}
#line 2529 "parser.tab.cpp"
    break;

  case 113: /* BuiltInTypeAssignment: GAUGE32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 885 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Gauge32");
}
#line 2538 "parser.tab.cpp"
    break;

  case 114: /* TypeOrTextualConvention: Type  */
#line 893 "parser.y"
{
   delete (yyvsp[0].pSyntax);
}
#line 2546 "parser.tab.cpp"
    break;

  case 115: /* TypeOrTextualConvention: TextualConventionAssignment  */
#line 897 "parser.y"
{
   delete (yyvsp[0].pSyntax);
}
#line 2554 "parser.tab.cpp"
    break;

  case 116: /* MacroAssignment: MACRO_SYM ASSIGNMENT_SYM Begin TokenList End  */
#line 904 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_MACRO;
   (yyval.pObject)->pszName = (yyvsp[-4].pszString);
}
#line 2564 "parser.tab.cpp"
    break;

  case 120: /* TextualConventionAssignment: TEXTUAL_CONVENTION_SYM TextualConventionDefinition  */
#line 922 "parser.y"
{
   (yyval.pSyntax) = s_currentSyntaxObject;
   s_currentSyntaxObject = nullptr;
}
#line 2573 "parser.tab.cpp"
    break;

  case 125: /* TextualConventionDefinitionElement: SnmpDescriptionStatement  */
#line 937 "parser.y"
{
	if (s_currentSyntaxObject != nullptr)
	{
		MemFree(s_currentSyntaxObject->pszDescription);
	}
	else
	{
		s_currentSyntaxObject = new MP_SYNTAX();
	}
	s_currentSyntaxObject->pszDescription = (yyvsp[0].pszString);
}
#line 2589 "parser.tab.cpp"
    break;

  case 127: /* TextualConventionDefinitionElement: SnmpSyntaxStatement  */
#line 950 "parser.y"
{
	if (s_currentSyntaxObject != nullptr)
	{
		s_currentSyntaxObject->nSyntax = (yyvsp[0].pSyntax)->nSyntax;
		MemFree(s_currentSyntaxObject->pszStr);
		s_currentSyntaxObject->pszStr = (yyvsp[0].pSyntax)->pszStr;
		(yyvsp[0].pSyntax)->pszStr = nullptr;
		delete (yyvsp[0].pSyntax);
	}
	else
	{
		s_currentSyntaxObject = (yyvsp[0].pSyntax);
	}
}
#line 2608 "parser.tab.cpp"
    break;

  case 128: /* SnmpNotificationTypeAssignment: Identifier NOTIFICATION_TYPE_SYM SnmpObjectsPart SnmpAccessPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 974 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_NOTIFTYPE;
   (yyval.pObject)->iAccess = (yyvsp[-4].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2628 "parser.tab.cpp"
    break;

  case 129: /* SnmpNotificationTypeAssignment: Identifier TRAP_TYPE_SYM ENTERPRISE_SYM LCidentifier SnmpTrapVariablePart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 995 "parser.y"
{
   MP_SUBID *pSubId;

   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_TRAPTYPE;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);

   pSubId = new MP_SUBID;
   pSubId->pszName = (yyvsp[-4].pszString);
   (yyval.pObject)->pOID->add(pSubId);

   pSubId = new MP_SUBID;
   pSubId->pszName = (char *)MemAlloc(strlen((yyvsp[-4].pszString)) + 3);
   sprintf(pSubId->pszName, "%s#0", (yyvsp[-4].pszString));
   pSubId->bResolved = TRUE;
   (yyval.pObject)->pOID->add(pSubId);

   for(int i = 0; i < (yyvsp[0].pOID)->size(); i++)
      (yyval.pObject)->pOID->add((yyvsp[0].pOID)->get(i));
   (yyvsp[0].pOID)->setOwner(Ownership::False);
   delete (yyvsp[0].pOID);

   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2662 "parser.tab.cpp"
    break;

  case 132: /* SnmpTrapVariableList: VARIABLES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1033 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2670 "parser.tab.cpp"
    break;

  case 137: /* SnmpMandatoryGroup: MANDATORY_GROUPS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1050 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2678 "parser.tab.cpp"
    break;

  case 142: /* SnmpComplianceObject: OBJECT_SYM LCidentifier SnmpSyntaxPart SnmpWriteSyntaxPart SnmpAccessPart SnmpDescriptionPart  */
#line 1071 "parser.y"
{
   MemFree((yyvsp[-4].pszString));
   delete (yyvsp[-3].pSyntax);
   MemFree((yyvsp[0].pszString));
}
#line 2688 "parser.tab.cpp"
    break;

  case 143: /* SnmpComplianceObject: GROUP_SYM LCidentifier SnmpDescriptionPart  */
#line 1077 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2697 "parser.tab.cpp"
    break;

  case 144: /* SnmpObjectsPart: OBJECTS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1085 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2705 "parser.tab.cpp"
    break;

  case 146: /* SnmpObjectsPart: NOTIFICATIONS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1090 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2713 "parser.tab.cpp"
    break;

  case 149: /* SnmpObjectGroupAssignment: LCidentifier OBJECT_GROUP_SYM SnmpObjectsPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 1104 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_OBJGROUP;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2728 "parser.tab.cpp"
    break;

  case 150: /* SnmpNotificationGroupAssignment: LCidentifier NOTIFICATION_GROUP_SYM SnmpObjectsPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 1123 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2742 "parser.tab.cpp"
    break;

  case 151: /* ModuleComplianceAssignment: LCidentifier MODULE_COMPLIANCE_SYM SnmpStatusPart SnmpDescriptionPart SnmpReferencePart SnmpModuleComplianceList AssignedIdentifier  */
#line 1141 "parser.y"
{
   MemFree((yyvsp[-6].pszString));
   MemFree((yyvsp[-3].pszString));
   delete (yyvsp[0].pOID);
}
#line 2752 "parser.tab.cpp"
    break;

  case 155: /* OptionalModuleName: UCidentifier  */
#line 1161 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2760 "parser.tab.cpp"
    break;

  case 161: /* SnmpVariationPart: VARIATION_SYM LCidentifier SnmpSyntaxPart SnmpWriteSyntaxPart SnmpAccessPart SnmpCreationPart SnmpDefValPart SnmpDescriptionPart  */
#line 1185 "parser.y"
{
   MemFree((yyvsp[-6].pszString));
   delete (yyvsp[-5].pSyntax);
   MemFree((yyvsp[0].pszString));
}
#line 2770 "parser.tab.cpp"
    break;

  case 164: /* ModuleCapabilitiesAssignment: SUPPORTS_SYM UCidentifier INCLUDES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM SnmpVariationsListPart  */
#line 1199 "parser.y"
{
   MemFree((yyvsp[-5].pszString));
   delete (yyvsp[-2].pList);
}
#line 2779 "parser.tab.cpp"
    break;

  case 165: /* ModuleCapabilitiesAssignment: ModuleIdentifier INCLUDES_SYM SymbolList SnmpVariationsListPart  */
#line 1204 "parser.y"
{
   MemFree((yyvsp[-3].pszString));
   delete (yyvsp[-1].pList);
}
#line 2788 "parser.tab.cpp"
    break;

  case 166: /* AgentCapabilitiesAssignment: LCidentifier AGENT_CAPABILITIES_SYM PRODUCT_RELEASE_SYM CharString SnmpStatusPart SnmpDescriptionPart SnmpReferencePart ModuleCapabilitiesList AssignedIdentifier  */
#line 1218 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-8].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-4].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_AGENTCAP;
   (yyval.pObject)->pszDescription = (yyvsp[-3].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   MemFree((yyvsp[-5].pszString));
}
#line 2804 "parser.tab.cpp"
    break;

  case 167: /* SnmpAccessPart: ACCESS_SYM LCidentifier  */
#line 1233 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2813 "parser.tab.cpp"
    break;

  case 168: /* SnmpAccessPart: MAX_ACCESS_SYM LCidentifier  */
#line 1238 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2822 "parser.tab.cpp"
    break;

  case 169: /* SnmpAccessPart: MIN_ACCESS_SYM LCidentifier  */
#line 1243 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2831 "parser.tab.cpp"
    break;

  case 170: /* SnmpAccessPart: %empty  */
#line 1248 "parser.y"
{
   (yyval.nInteger) = 0;
}
#line 2839 "parser.tab.cpp"
    break;

  case 171: /* SnmpStatusPart: STATUS_SYM LCidentifier  */
#line 1255 "parser.y"
{
   static const char *pStatusText[] = { "mandatory", "optional", "obsolete", "deprecated", "current", NULL };
   int i;

   for(i = 0; pStatusText[i] != NULL; i++)
      if (!stricmp(pStatusText[i], (yyvsp[0].pszString)))
      {
         (yyval.nInteger) = i + 1;
         break;
      }
   if (pStatusText[i] == NULL)
   {
      char szBuffer[256];

      sprintf(szBuffer, "Invalid STATUS value \"%s\"", (yyvsp[0].pszString));
      mperror(szBuffer);
   }
   MemFree((yyvsp[0].pszString));
}
#line 2863 "parser.tab.cpp"
    break;

  case 174: /* SnmpReferenceStatement: REFERENCE_SYM CharString  */
#line 1283 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2871 "parser.tab.cpp"
    break;

  case 175: /* SnmpDisplayHintStatement: DISPLAY_HINT_SYM CharString  */
#line 1290 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2879 "parser.tab.cpp"
    break;

  case 176: /* SnmpIndexPart: INDEX_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1297 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2887 "parser.tab.cpp"
    break;

  case 177: /* SnmpIndexPart: AUGMENTS_SYM LEFT_BRACE_SYM DefinedValue RIGHT_BRACE_SYM  */
#line 1301 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
}
#line 2895 "parser.tab.cpp"
    break;

  case 181: /* SnmpDefValPart: DEFVAL_SYM LEFT_BRACE_SYM CharString RIGHT_BRACE_SYM  */
#line 1311 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
}
#line 2903 "parser.tab.cpp"
    break;

  case 182: /* SnmpDefValPart: DEFVAL_SYM LEFT_BRACE_SYM Identifier RIGHT_BRACE_SYM  */
#line 1315 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
}
#line 2911 "parser.tab.cpp"
    break;

  case 184: /* SnmpDefValPart: DEFVAL_SYM AssignedIdentifierList  */
#line 1320 "parser.y"
{
   delete (yyvsp[0].pOID);
}
#line 2919 "parser.tab.cpp"
    break;

  case 188: /* DefValListElement: LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1333 "parser.y"
{
   delete (yyvsp[-1].pList);
}
#line 2927 "parser.tab.cpp"
    break;

  case 190: /* BinaryString: BSTRING_SYM  */
#line 1341 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2935 "parser.tab.cpp"
    break;

  case 191: /* HexString: HSTRING_SYM  */
#line 1348 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 2943 "parser.tab.cpp"
    break;

  case 192: /* CharString: CSTRING_SYM  */
#line 1355 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2951 "parser.tab.cpp"
    break;

  case 193: /* SymbolsFromModuleList: SymbolsFromModuleList SymbolsFromModule  */
#line 1362 "parser.y"
{
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 2959 "parser.tab.cpp"
    break;

  case 194: /* SymbolsFromModuleList: SymbolsFromModule  */
#line 1366 "parser.y"
{
   (yyval.pImportList) = new ObjectArray<MP_IMPORT_MODULE>(16, 16, Ownership::True);
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 2968 "parser.tab.cpp"
    break;

  case 195: /* SymbolsFromModule: SymbolList FROM_SYM UCidentifier  */
#line 1374 "parser.y"
{
   (yyval.pImports) = new MP_IMPORT_MODULE;
   (yyval.pImports)->pszName = (yyvsp[0].pszString);
   delete (yyval.pImports)->pSymbols;
   (yyval.pImports)->pSymbols = (yyvsp[-2].pList);
}
#line 2979 "parser.tab.cpp"
    break;

  case 196: /* SymbolList: SymbolList COMMA_SYM Symbol  */
#line 1384 "parser.y"
{
   (yyval.pList)->add((yyvsp[0].pszString));
}
#line 2987 "parser.tab.cpp"
    break;

  case 197: /* SymbolList: Symbol  */
#line 1388 "parser.y"
{
   (yyval.pList) = new Array(16, 16, Ownership::True);
   (yyval.pList)->add((yyvsp[0].pszString));
}
#line 2996 "parser.tab.cpp"
    break;

  case 198: /* Symbol: UCidentifier  */
#line 1396 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3004 "parser.tab.cpp"
    break;

  case 199: /* Symbol: LCidentifier  */
#line 1400 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3012 "parser.tab.cpp"
    break;

  case 200: /* Symbol: IMPLIED_SYM LCidentifier  */
#line 1404 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3020 "parser.tab.cpp"
    break;

  case 201: /* SequenceItem: Identifier Type  */
#line 1411 "parser.y"
{
   MemFree((yyvsp[-1].pszString));
   delete (yyvsp[0].pSyntax);
}
#line 3029 "parser.tab.cpp"
    break;

  case 209: /* SnmpTypeTagItem: LEFT_BRACKET_SYM UCidentifier Number RIGHT_BRACKET_SYM  */
#line 1438 "parser.y"
{
   MemFree((yyvsp[-2].pszString));
}
#line 3037 "parser.tab.cpp"
    break;

  case 220: /* Value: CharString  */
#line 1458 "parser.y"
{
   MemFree((yyvsp[0].pszString));
}
#line 3045 "parser.tab.cpp"
    break;

  case 221: /* Identifier: UCidentifier  */
#line 1465 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3053 "parser.tab.cpp"
    break;

  case 222: /* Identifier: LCidentifier  */
#line 1469 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3061 "parser.tab.cpp"
    break;

  case 223: /* UCidentifier: UCASEFIRST_IDENT_SYM  */
#line 1476 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3069 "parser.tab.cpp"
    break;

  case 224: /* LCidentifier: LCASEFIRST_IDENT_SYM  */
#line 1483 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3077 "parser.tab.cpp"
    break;


#line 3081 "parser.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1496 "parser.y"


MP_MODULE *ParseMIB(const TCHAR *fileName)
{
   m_pModule = NULL;
   mpin = _tfopen(fileName, _T("r"));
   if (mpin != NULL)
   {
#ifdef UNICODE
	  WideCharToMultiByteSysLocale(fileName, s_currentFilename, MAX_PATH);
#else
	  s_currentFilename = fileName;
#endif
      g_nCurrLine = 1;
      InitStateStack();
      /*mpdebug=1;*/
      ResetScanner();
      mpparse();
      fclose(mpin);
   }
   else
   {
#ifdef UNICODE
      char *name = MBStringFromWideString(fileName);
      Error(ERR_CANNOT_OPEN_FILE, name, strerror(errno));
      MemFree(name);
#else
      Error(ERR_CANNOT_OPEN_FILE, fileName, strerror(errno));
#endif
      return NULL;
   }
   return m_pModule;
}

extern "C" int mpwrap()
{
	return 1;
}

int mperror(const char *pszMsg)
{
   Error(ERR_PARSER_ERROR, s_currentFilename, pszMsg, g_nCurrLine);
   return 0;
}
